Subject: shr mangling messages
From: 積丹尼 Dan Jacobson <[email-masked]>
To: bug-gnu-emacs <[email-masked]>
Cc: Katsumi Yamaoka <[email-masked]>
Date: Mon, 31 Oct 2016 10:45:58 +0800
List-Id: <debbugs-submit.debbugs.gnu.org>

Gentelmen, the "shr" program is mangling messages.

It could remove vital words, causing arguments:

"I did include the address!" "No you didn't." "Yes I did. Your mail
reader probably cut it out."

We're talking data loss here. It may still be on the disk, but not shown
to the user.

True, the HTML might not be perfect, but at least Chromium, Firefox,
etc. show it fine.

>>>>> "KY" == Katsumi Yamaoka <[email-masked]> writes:

KY> Emacs-w3m renders it as:

KY>  http://w                                                                     
KY>           Hi, you have a new email from Catherineme                           
KY>  [25]                                                                         
KY>           View your inbox at http://www.travel-buddies.com/Inbox.aspx         
                                                                              
KY>  © Travel Buddies 2015 | All rights reserved                                  

Hmmm, w3m -dump on the attachment shows the first URL in full.

KY> However shr renders it as:

KY> Travel Buddies

KY>   © Travel Buddies 2015 | All rights reserved    
KY> http://www.travel-buddies.com/ 
KY> * 

KY> There lacks the "Hi, you have a new mail" message.  The return
KY> value of `libxml-parse-html-region' contains the message as

KY> (h1 nil (span nil "Hi, you have a new email from") "Catherineme")
KY> (p nil "View your inbox at "
KY>    (a ((href . "http://www.travel-buddies.com/Inbox.aspx"))
KY>       "http://www.travel-buddies.com/Inbox.aspx"))

KY> regardless of whether all style specs are removed[1] or not
KY> (three nil portions above are replaced with style specs if they
KY>  are not removed).  So, style specs are not cause of not
KY> displaying some meaningful message in an html mail, I believe.
KY> In that case, making shr display images does not help.

KY> I think there's something wrong in shr.el, and what you should
KY> do would be to send a bug report to the Emacs bug team, i.e.,
KY> M-x report-emacs-bug, with the sample html part (I'm not so
KY> familiar with recent shr, sorry).  Note that a mail containing
KY> html part might be rejected by the server, so putting it in your
KY> web site separately would be better.

KY> [1] I tested it by modifying mm-shr so as to remove style specs.

OK I'll send the message,

here in this bug report about In GNU Emacs 24.5.1 (i686-pc-linux-gnu,
GTK+ Version 3.21.5) of 2016-09-06 on x86-csail-01, modified by Debian.